{% extends 'main_app/base.html' %}

{% load static %}

{% block specific_css %}
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="{% static 'assignments/css/form.css' %}">
{% endblock specific_css %}

{% block content %}
    {# Django Tempus Dominus assets are included in `{{ form.media }}` #}
    {{ form.media }}

    <div class="container">
        <div class="row my-5">
            <div class="col-1"></div>
            <div class="col-10">
                <h1>New Language</h1>
                {% if form.errors %}
                    {% for field in form %}
                        {% for error in field.errors %}
                            <div class="alert alert-danger">
                                <strong>{{ error|escape }}</strong>
                            </div>
                        {% endfor %}
                    {% endfor %}
                    {% for error in form.non_field_errors %}
                        <div class="alert alert-danger">
                            <strong>{{ error|escape }}</strong>
                        </div>
                    {% endfor %}
                {% endif %}
                <form method="post" enctype="multipart/form-data" onsubmit="clearStorage()">
                    {% csrf_token %}
                    <div class="form-group">
                        <label for="id_name"><strong>Language Name<span
                                class="required_field">*</span></strong></label>
                        {{ form.name }}
                    </div>
                    <div class="form-group">
                        <label for="id_compile_command"><strong>Compile Command</strong></label>
                        <small id="source_help" class="form-text text-muted">The commands are run on the file directory. Following tokens are available:
                            <ul>
                                <li>{file} for the filename.</li>
                                <li>{efile} for the extensionless filename.</li>
                            </ul>
                        </small>
                        {{ form.compile_command }}
                        <small id="source_help" class="form-text text-muted">Leave empty if the language is interpreted.</small>
                    </div>
                    <div class="form-group">
                        <label for="id_run_command"><strong>Run Command<span
                                class="required_field">*</span></strong></label>
                        <small id="source_help" class="form-text text-muted">The same tokens from above are available.</small>
                        {{ form.run_command }}
                    </div>
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
            </div>
        </div>
    </div>
{% endblock content %}

{% block specific_js %}
    <script type="text/javascript">
        let saveStorage = true;

        // save field values
        window.onbeforeunload = () => {
            if (saveStorage) {
                sessionStorage.setItem("name", $('#id_name').val());
                sessionStorage.setItem("compile_command", $('#id_compile_command').val());
                sessionStorage.setItem("run_command", $('#id_run_command').val());
            }
        };

        // restore field values
        window.onload = () => {
            let name = sessionStorage.getItem("name");
            if (name !== null) $('#id_name').val(name);
            let compile_command = sessionStorage.getItem("compile_command");
            if (compile_command !== null) $('#id_compile_command').val(compile_command);
            let run_command = sessionStorage.getItem("run_command");
            if (run_command !== null) $('#id_run_command').val(run_command);
        };

        function clearStorage() {
            saveStorage = false;
            sessionStorage.clear();
        }
    </script>
{% endblock specific_js %}
